<!doctype html>

<html lang="en">

<head>
	<meta charset="utf-8" />
	<title>Tango2Epics Tango</title>
	
	<link rel="stylesheet" href="index.css"/>
</head>

<body>
	<div id="wrapper_all">
	
		<div id="topMenu">
			<table width="100%" border="1">
				<thead>
					<tr><td colspan="5">Tango2Epics Tango Device</td></tr>
				</thead>
				<tbody>
					<tr>
						<td><a href="./index.html">Description</a></td>
						<td><a href="./properties.html">Properties</a></td>
						<td><a href="./Commands.html">Commands</a></td>
						<td><a href="./Attributes.html">Attributes</a></td>
						<td><a href="./States.html">States</a></td>
					</tr>
				</tbody>
			</table>
		</div>
		
		<div id="topDiv">
			<div id="topLeftDiv">
			<table id="DeviceProps" border="1">
				<thead>
					<tr>
						<td colspan="3">Tango2Epics Device Properties</td>
					</tr>
					<tr>
						<td>Name</td>
						<td>Description</td>
						<td>Format</td>
					</tr>
				</thead>
				
				<tbody>
					<tr>
						<td>Variables:</td>
						<td>This is the property, that defines which PVs will be linked to what Tango attributes, commands or states.
						It consists of multiple items, each specifying one PV and its properties. Additionally it provides the configuration for linking the PV to the Tango attributes, commands or states.
						See the Variables Extended BNF Format and bellow description for the format of this property and its items.</td>
						<td>VARIABLES<br>
						See the Variables Extended BNF Format</td>
					</tr>
					<tr>
						<td>ScalarAccessTimeout:</td>
						<td>This property specifies the value of the preferred timeout (in seconds) for when trying to access a scalar PV.</td>
						<td>SCALAR_ACCESS_TIMEOUT<br>
						See the ScalarAccessTimeout Extended BNF Format</td>
					</tr>
					<tr>
						<td>ArrayAccessTimeout:</td>
						<td>This property specifies the value of the preferred timeout (in seconds) for when trying to access a array PV.</td>
						<td>SCALAR_ACCESS_TIMEOUT<br>
						See the ArrayAccessTimeout Extended BNF Format</td>
					</tr>
					<tr>
						<td>SubscriptionCycle:</td>
						<td>This property specifies the value of the time period for subscription cycles.<br>
						Note: when closing the application, it might take one subscription cycle period of time to close the subscriptions.</td>
						<td>SUBSCRIPTION_CYCLE<br>
						See the SubscriptionCycle Extended BNF Format</td>
					</tr>
				</tbody>
			</table>
			</div>
			
			<div id="topRightDiv">
			<table id="Format" border="1">
				<thead>
					<tr>
						<td colspan="2">Variables Extended BNF Format</td>
					</tr>
				</thead>
				
				<tbody>
					<tr>
						<td>VARIABLES =</td>
						<td>
							1*(VARIABLE);
						</td>
					</tr>
					<tr>
						<td>VARIABLE =</td>
						<td>
							PV_IDENTIFIER, "*", PV_DIM, "*", PV_TYPE , "*", PV_ACCESS, "*", FUNC_TYPE, "*", MAP_LOGIC;
						</td>
					</tr>
					<tr>
						<td>PV_DIM =</td>
						<td>
							"Scalar" | ("Array:", ARRAY_SIZE)
						</td>
					</tr>
					<tr>
						<td>PV_TYPE =</td>
						<td>
							"Short" | "Enum" | "Int" | "Long" | "Float" | "Double" | "Byte" | "Char" | "String";
						</td>
					</tr>
					<tr>
						<td>PV_ACCESS =</td>
						<td>
							"READ_ONLY" | "WRITE_ONLY" | "READ_WRITE";
						</td>
					</tr>
					<tr>
						<td>FUNC_TYPE =</td>
						<td>
							"ATTRIBUTE" | "COMMAND" | "STATE";
						</td>
					</tr>
					<tr>
						<td>If(FUNC_TYPE == "ATTRIBUTE") MAP_LOGIC =</td>
						<td>
							ATTRIBUTE_NAME | "";
						</td>
					</tr>
					<tr>
						<td>If(FUNC_TYPE == "COMMAND") MAP_LOGIC =</td>
						<td>
							COMMAND_VALUE, ":", COMMAND_NAME, *(".", COMMAND_VALUE, ":", COMMAND_NAME);
						</td>
					</tr>
					<tr>
						<td>If(FUNC_TYPE == "STATE") MAP_LOGIC =</td>
						<td>
							STATE_VALUE, ":", STATE_NAME, *(".", STATE_VALUE, ":", STATE_NAME);
						</td>
					</tr>
				</tbody>
				<thead>
					<tr>
						<td colspan="2">ScalarAccessTimeout Extended BNF Format</td>
					</tr>
				</thead>
				<tbody>
					<tr>
						<td>SCALAR_ACCESS_TIMEOUT =</td>
						<td>
							SCALAR_ACCESS_TIMEOUT_VALUE
						</td>
					</tr>
				</tbody>
				<thead>
					<tr>
						<td colspan="2">ArrayAccessTimeout Extended BNF Format</td>
					</tr>
				</thead>
				<tbody>
					<tr>
						<td>ARRAY_ACCESS_TIMEOUT =</td>
						<td>
							ARRAY_ACCESS_TIMEOUT_VALUE
						</td>
					</tr>
				</tbody>
				<thead>
					<tr>
						<td colspan="2">SubscriptionCycle Extended BNF Format</td>
					</tr>
				</thead>
				<tbody>
					<tr>
						<td>SUBSCRIPTION_CYCLE =</td>
						<td>
							SUBSCRIPTION_CYCLE_VALUE
						</td>
					</tr>
				</tbody>
			</table>
			</div>
		</div>
		
		<div id="middleDiv">
			
			<table id="ClassDesc" border="1">
				<thead>
					<tr>
						<td colspan="2">Additional Information</td>
					</tr>
					<tr>
						<td>Item</td>
						<td>Description</td>
					</tr>
				</thead>
				<tbody>
					<tr>
						<td>TANGO_DEVICE_NAME</td>
						<td>Tango device name</td>
					</tr>
					<tr>
						<td>PV_IDENTIFIER</td>
						<td>Process Variable name, identifier</td>
					</tr>
					<tr>
						<td>PV_DIM</td>
						<td>For scalar use: "Scalar"<br>
						For array use: "Array:S", where S is the size of the array</td>
					</tr>
					<tr>
						<td>PV_TYPE</td>
						<td>Short, Enum, Int, Long, Float, Double, Byte, Char or String.</td>
					</tr>
					<tr>
						<td>PV_ACCESS</td>
						<td>READ_ONLY, READ_WRITE or WRITE_ONLY</td>
					</tr>
					<tr>
						<td>FUNC_TYPE</td>
						<td>For attribute: ATTRIBUTE<br>
						For command: COMMAND<br>
						For state: STATE</td>
					</tr>
					<tr>
						<td>MAP_LOGIC</td>
						<td>Additional mapping logic, needed when mapping to a command or a state. Also used for providing an attribute name, when mapping a PV to an attribute. In the latter case, if the MAP_LOGIC is not provided, a PV_INDENTIFIER will be used as the attribute name.<br>
						<br>
						Example for state:        1:ON.2:OFF.3:FAULT<br>
						(When the value of the specified PV will equal "1", the device will go to state "ON". When it will equal "2", the device will go to state "OFF" etc.)<br>
						<br>
						Example for state:     1:ON.2:OFF.3:RESET<br>
						(When the command "ON" will be executed, then the value of the specified PV will be set to "1". With command "OFF", it will be set to "2" etc.)<br>
						<br>
						Note: when using char or string, the value must be an ASCII representation of the value. Otherwise, the numerical value ought to be used.</td>
					</tr>
					<tr>
						<td>SCALAR_ACCESS_TIMEOUT_VALUE</td>
						<td>Preferred timeout (in seconds) for when trying to access a scalar PV.<br>
						Double value.</td>
					</tr>
					<tr>
						<td>ARRAY_ACCESS_TIMEOUT_VALUE</td>
						<td>Preferred timeout (in seconds) for when trying to access an array PV.<br>
						Double value.</td>
					</tr>
					<tr>
						<td>SUBSCRIPTION_CYCLE_VALUE</td>
						<td>Time period for subscription cycles.<br>
						Double value.<br>
						Note: when closing the application, it might take one subscription cycle period of time to close the subscriptions. </td>
					</tr>
				</tbody>
			</table>
		</div>
		
	</div>
</body>

</html>